%define version 4.0.1
%define so_version 4
%define release C1

Name: php
Summary: PHP: Hypertext Preprocessor
Group: Development/Languages
Version: %{version}
Release: %{release}
Copyright: The PHP license (see "LICENSE" file included in distribution)
Source: http://www.php.net/version4/downloads/php-%{version}.tar.gz
Patch0: php-4.0.1-config.patch
Patch1: php-4.0.0-security.patch
Patch2: php-4.0.1-4.0.1pl2.diff.gz
#Icon: php4.gif
URL: http://www.php.net/
Packager: PHP Group <group@php.net>

# this is really bad, but interbase doesn't have a versioned soname
Provides: libgds.so

BuildRoot: /var/tmp/php-%{version}

%description
PHP is an HTML-embedded scripting language. Much of its syntax is
borrowed from C, Java and Perl with a couple of unique PHP-specific
features thrown in. The goal of the language is to allow web
developers to write dynamically generated pages quickly.

%package devel
Group: Development/Libraries
Summary: development headers for php

%description devel
The php-devel package contains the code necessary for building dynamic
shared libraries for PHP.


%prep

%setup
%patch0 -p1 -b .config
%patch1 -p1 -b .security
%patch2 -p1 -b .pl2

%build
set -x
APXS=/usr/sbin/apxs

# we need to configure first, or we get stuff confused
./configure --prefix=/usr --with-apxs=$APXS --enable-track-vars \
	    --disable-debug --enable-xml

# figure out configure options options based on what packages are installed
# to override, use the OVERRIDE_OPTIONS environment variable.  To add
# extra options, use the OPTIONS environment variable.

OPTIONS="$OPTIONS --with-gd --with-gettext --enable-safe-mode \
	 --with-config-file-path=/etc/httpd --with-exec-dir=/usr/bin \
	 --with-zlib --enable-magic-quotes --with-regex=system \
  	 --with-ttf=/usr/lib/libttf.so --enable-track-vars \
	 --enable-xml --disable-debug"
test `rpm -q db3-devel` && OPTIONS="$OPTIONS --with-db3"
test `rpm -q InterBaseCS_LI` && OPTIONS="$OPTIONS --with-interbase=shared"
test `rpm -q MySQL-devel` && OPTIONS="$OPTIONS --with-mysql=shared"
test `rpm -q solid-devel` && OPTIONS="$OPTIONS --with-solid"
test `rpm -q postgresql-devel` && OPTIONS="$OPTIONS --with-pgsql=shared"
test `rpm -q openldap-devel` && OPTIONS="$OPTIONS --with-ldap"
test `rpm -q imap-devel` && OPTIONS="$OPTIONS --with-imap"
# fail if we don't have imap support:
test `rpm -q imap-devel`
# imap needs this:
test -e /usr/lib/libc-client.a || ln -s /usr/lib/c-client.a /usr/lib/libc-client.a

./buildconf
if test "x$OVERRIDE_OPTIONS" = "x"; then
    CFLAGS="-DEAPI $RPM_OPT_FLAGS" ./configure --prefix=/usr --with-apxs=$APXS $OPTIONS
else
    CFLAGS="$RPM_OPT_FLAGS" ./configure $OVERRIDE_OPTIONS
fi

make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/lib/apache
mkdir -p $RPM_BUILD_ROOT/usr/lib/apache/php
mkdir -p $RPM_BUILD_ROOT/usr/local/include/php
mkdir -p $RPM_BUILD_ROOT/usr/local/include/php/Zend
mkdir -p $RPM_BUILD_ROOT/usr/local/include/php/ext/standard
mkdir -p $RPM_BUILD_ROOT/usr/local/include/php/regex
#strip --strip-debug .libs/libphp4.so
install -m 755 .libs/libphp4.so $RPM_BUILD_ROOT/usr/lib/apache
install -m 755 modules/*.so $RPM_BUILD_ROOT/usr/lib/apache/php

# ewww. ugliness. php isn't very well laid out in terms of its 
# dynamic module interface. we just copy all of the header files for
# now.
# php header files
install -m 644 php_version.h php_config.h main/{php*,safe_mode,fopen-wrappers}.h $RPM_BUILD_ROOT/usr/local/include/php
# zend header files
install -m 644 Zend/*.h $RPM_BUILD_ROOT/usr/local/include/php/Zend
# the rest of this nastiness
install -m 644 ext/standard/php_output.h $RPM_BUILD_ROOT/usr/local/include/php/ext/standard
install -m 644 regex/regex.h $RPM_BUILD_ROOT/usr/local/include/php/regex
install -m 644 regex/regex_extra.h $RPM_BUILD_ROOT/usr/local/include/php/regex/regex_extra.h

# install the commandline version. this is a massive hack, but the
# php build system doesn't allow you to build both the mod_php and 
# commandline version at the same time. 
CFLAGS="-g $CFLAGS" ./configure --disable-apxs
make clean
make

mkdir -p $RPM_BUILD_ROOT/usr/bin/
install -m 755 php $RPM_BUILD_ROOT/usr/bin/php

%files
/usr/bin/php
/usr/lib/apache/*

%files devel
/usr/local/include/php/*


